<map version="0.7.1">
<node TEXT="Ship-Simu Ship-Simulation">
<font NAME="SansSerif" BOLD="true" SIZE="18"/>
<node TEXT="Browser-Game" POSITION="right">
<font NAME="SansSerif" BOLD="true" SIZE="16"/>
<icon BUILTIN="messagebox_warning"/>
<node TEXT="Tick-based simulation">
<node TEXT="Cronological job (cron)">
<node TEXT="Addional requirement for installation"/>
</node>
</node>
<node TEXT="Click-based simulation">
<node TEXT="User clicks a button, action performed"/>
</node>
<node TEXT="Pseudo-3D graphics">
<node TEXT="Still graphics">
<node TEXT="Different ships">
<node TEXT="Passenger ship"/>
<node TEXT="Oil tanker"/>
<node TEXT="Container ship"/>
<node TEXT="Misc small ships"/>
</node>
<node TEXT="Buildings">
<node TEXT="Shipyard"/>
<node TEXT="Dry dock"/>
<node TEXT="Terminal building"/>
</node>
<node TEXT="Vehicles">
<node TEXT="Container carrier"/>
<node TEXT="Crane"/>
</node>
<node TEXT="All pics should be self-shooted">
<node TEXT="This avoids copyright conflicts"/>
<node TEXT="The requested buildings/vehicles must be found in reality"/>
</node>
</node>
<node TEXT="Slightly moved graphics (GIF)">
<node TEXT="Water surface"/>
<node TEXT="Sky texture"/>
</node>
</node>
<node TEXT="Fully XHTML 1.0">
<node TEXT="Latest Internet standard"/>
<node TEXT="Older browsers will make lesser trouble"/>
<node TEXT="Should validate with the W3C HTML Validator">
<node LINK="http://validator.w3.org" TEXT="http://validator.w3.org">
<icon BUILTIN="attach"/>
</node>
</node>
</node>
<node TEXT="Design is CSS-based">
<font NAME="SansSerif" SIZE="12"/>
<node TEXT="Themes are possible"/>
</node>
<node TEXT="Nice AJAX features">
<icon BUILTIN="idea"/>
<icon BUILTIN="desktop_new"/>
</node>
<node TEXT="Website structure">
<font NAME="SansSerif" BOLD="true" SIZE="14"/>
<node TEXT="External guest area">
<font NAME="SansSerif" BOLD="true" SIZE="12"/>
<node TEXT="News on the front page (home)">
<node TEXT="The news source can be choosen from different">
<node TEXT="Previously typed and stored in database"/>
<node TEXT="Local XML files">
<node TEXT="Hint: Created by external generators">
<font NAME="SansSerif" SIZE="12"/>
</node>
</node>
<node TEXT="Remote XMLs like RSS feeds"/>
</node>
<node TEXT="The typer can choose a category">
<node TEXT="New categories can be suggested by the typer"/>
<node TEXT="An admin can create new categories"/>
</node>
<node TEXT="Comments are allowable">
<node TEXT="Logged-in users"/>
<node TEXT="Guests as well">
<icon BUILTIN="clanbomber"/>
<node TEXT="Secured with CAPTCHA">
<icon BUILTIN="messagebox_warning"/>
</node>
</node>
</node>
<node TEXT="One object for all news should be fine">
<node TEXT="Do not use one object per news entry!">
<icon BUILTIN="clanbomber"/>
<icon BUILTIN="stop"/>
</node>
<node TEXT="The object receives a &quot;Requestable&quot; object">
<node TEXT="Obtain page number and sent comment data from it"/>
</node>
</node>
</node>
<node TEXT="Registration form" STYLE="fork">
<node TEXT="One single page"/>
<node TEXT="Multiple pages"/>
</node>
<node TEXT="Login form">
<node TEXT="With guest login (disable by the admin)"/>
<node TEXT="Password reminder"/>
<node TEXT="Link to the registration form"/>
</node>
<node TEXT="Screenshot gallery">
<node TEXT="Comments are allowable"/>
<node TEXT="Should be kept simple"/>
</node>
<node TEXT="List of enabled features" STYLE="fork"/>
<node TEXT="Statistics of the game (not whole network!)"/>
<node TEXT="List of playing users">
<node TEXT="With link to their public profiles"/>
</node>
<node TEXT="Pillory">
<node TEXT="Username (who got locked)"/>
<node TEXT="Date&amp;Time"/>
<node TEXT="The admin"/>
<node TEXT="Stated reason"/>
</node>
<node TEXT="Small extra pages">
<node TEXT="Imprint (required in Germany)"/>
<node TEXT="Privacy policy (required in some countries)"/>
</node>
</node>
<node TEXT="Internal game area">
<font NAME="SansSerif" BOLD="true" SIZE="12"/>
<node TEXT="News on first login page">
<node TEXT="Like on &quot;home&quot; page except that there is no captcha required"/>
<node TEXT="Including history of recent events since last login"/>
</node>
<node TEXT="Create new game character">
<edge STYLE="bezier"/>
<cloud/>
<font NAME="SansSerif" SIZE="12"/>
<icon BUILTIN="password"/>
<node TEXT="The gamer can have all varriants">
<node TEXT="This may be limitable by admin"/>
<node TEXT="The player still cannot make contracts with own characters">
<icon BUILTIN="messagebox_warning"/>
</node>
</node>
<node TEXT="It should cost somewhere a fee">
<node TEXT="The fee shall be payed from user account"/>
</node>
<node TEXT="For first character creation he shall have enougth game money plus some extra"/>
<node TEXT="Types of characters">
<node TEXT="Shipping company founder">
<node TEXT="This includes the fee for funding new company"/>
</node>
<node TEXT="Jobholder">
<node TEXT="Starts unemployed"/>
<node TEXT="Some money left for sending applications out"/>
<node TEXT="May ask goverment for financial help"/>
<node TEXT="Has to pay monthly fees">
<icon BUILTIN="stop"/>
<node TEXT="Rent for a &quot;fake&quot; house"/>
<node TEXT="Meal and drinks (faked)"/>
<node TEXT="Others costs like phone,electricity"/>
</node>
</node>
<node TEXT="Merchant">
<node TEXT="Raw resources"/>
<node TEXT="Constructed ship parts"/>
<node TEXT="Smaller complete ships"/>
</node>
<node TEXT="Marketing Agency">
<node TEXT="Sells marketing/merchandising products"/>
</node>
</node>
</node>
<node TEXT="Load existing character">
<cloud/>
<font NAME="SansSerif" SIZE="12"/>
<icon BUILTIN="password"/>
<node TEXT="Contains link to &quot;Create new character&quot;"/>
<node TEXT="Player sees some basic data about listed characters"/>
<node TEXT="Locked characters should not be removed instead marked with &quot;Locked&quot;"/>
</node>
<node TEXT="Refill account points">
<node TEXT="The admin may choose if the in-game can be converted with a low rate to account points"/>
<node TEXT="This option might be disabled by admin">
<node TEXT="Then the gamer can only refill in-game money per character"/>
</node>
</node>
<node TEXT="Update gamer/user profile">
<node TEXT="Enter the current account password"/>
<node TEXT="Send email to the user only if no email has changed, or if ..."/>
<node TEXT="Has the email been changed?">
<icon BUILTIN="help"/>
<node TEXT="Send new confirmation to new email"/>
<node TEXT="Send notifier to old email"/>
</node>
</node>
<node TEXT="Change account password">
<node TEXT="Enter current account password"/>
<node TEXT="Enter new password twice"/>
<node TEXT="Send an email to the user"/>
</node>
</node>
<node TEXT="General infrastructures">
<font NAME="SansSerif" BOLD="true" SIZE="12"/>
<node TEXT="Point system (in-game money)">
<font NAME="SansSerif" SIZE="12"/>
<icon BUILTIN="password"/>
</node>
<node TEXT="A.I. goverment">
<cloud/>
<icon BUILTIN="flag"/>
<icon BUILTIN="password"/>
<node TEXT="Shall help unemployed gamers staying alive (but not becoming rich)"/>
<node TEXT="May later on collect taxes from companies">
<node TEXT="For paying unemployed people"/>
<node TEXT="Financial support for broken companies"/>
</node>
<node TEXT="May ofer social security services">
<icon BUILTIN="xmag"/>
<icon BUILTIN="pencil"/>
</node>
<node TEXT="Goverment is not playable at the moment">
<font NAME="SansSerif" SIZE="12"/>
<icon BUILTIN="messagebox_warning"/>
<node TEXT="It should be &quot;played&quot; abstractly by the server"/>
<node TEXT="Gamers may help each other with financial support"/>
</node>
</node>
</node>
</node>
<node TEXT="Strict coding guidelines for clean PHP code">
<font NAME="SansSerif" BOLD="true" SIZE="14"/>
<icon BUILTIN="xmag"/>
<node TEXT="General code structure">
<font NAME="SansSerif" BOLD="true" SIZE="12"/>
<icon BUILTIN="messagebox_warning"/>
<node TEXT="Fully object-oriented">
<node TEXT="Use of different but practical design patterns">
<node TEXT="Factory-method pattern for smother initializing of objects"/>
<node TEXT="Template method pattern where it matches"/>
<node TEXT="MVC pattern for the website core"/>
</node>
<node TEXT="Only one index.php shall provide access to the whole game"/>
<node TEXT="Slower in PHP5">
<icon BUILTIN="clanbomber"/>
</node>
</node>
</node>
<node TEXT="Documentation">
<font NAME="SansSerif" BOLD="true" SIZE="12"/>
<node TEXT="In-line documentation">
<node TEXT="Script header with full copyright and license as requested by GNU GPL 3"/>
<node TEXT="Method headers with Doxygen compatible tags"/>
<node TEXT="Comments above single lines for better understanding what is happening"/>
</node>
<node TEXT="Files in directory &quot;docs&quot;">
<node TEXT="COPYING*">
<node TEXT="License files"/>
</node>
<node TEXT="Conception">
<node TEXT="As OpenDocument and later PDF as well"/>
</node>
<node TEXT="NEWS">
<node TEXT="Latest news around the game (coeer and gamer)"/>
</node>
<node TEXT="README">
<node TEXT="Includes installation instructions and general gaming guidelines"/>
</node>
<node TEXT="ArgoUML diagram">
<node TEXT="For visualization of the class structure"/>
</node>
<node TEXT="FreeMind document">
<node TEXT="...">
<icon BUILTIN="ksmiletris"/>
</node>
</node>
<node TEXT="THANKS">
<node TEXT="All people helped in some direct or indirect way, less or more."/>
</node>
<node TEXT="minmap_yyyymmdd.html">
<node TEXT="Exported FreeMind maps to HTML with CSS and JavaScript"/>
</node>
</node>
</node>
<node TEXT="Folding of the code">
<font NAME="SansSerif" BOLD="true" SIZE="12"/>
</node>
<node TEXT="Tabs and spaces">
<font NAME="SansSerif" BOLD="true" SIZE="12"/>
</node>
</node>
</node>
<node TEXT="How does a shipping company work?" POSITION="left">
<font NAME="SansSerif" BOLD="true" SIZE="16"/>
<icon BUILTIN="messagebox_warning"/>
<node TEXT="Start as a founder by selecting a harbor">
<cloud/>
<node TEXT="Construct neccessary buildings">
<node TEXT="Make contract with construction companies"/>
</node>
<node TEXT="Order ship parts">
<node TEXT="Fron your partners"/>
<node TEXT="On global market"/>
</node>
<node TEXT="Make contracts with other companies">
<node TEXT="Construct ships for your partner"/>
<node TEXT="Drive constructed ships by your partner"/>
</node>
<node TEXT="Build ship parts and trade them"/>
<node TEXT="Become CEO and manage your company">
<node TEXT="Nominate department managers"/>
<node TEXT="Recruit new employees"/>
<node TEXT="Pay salery to your employees"/>
</node>
<node TEXT="Let other gamer manage your company"/>
<node TEXT="Compare prices">
<node TEXT="Make a purchase computation system"/>
</node>
<node TEXT="Manage a journey"/>
</node>
<node TEXT="Or start as an employee">
<cloud/>
<node TEXT="Start as a simple sailor">
<node TEXT="And end up as a captain">
<node TEXT="Control your ship (depends on client)"/>
</node>
</node>
<node TEXT="Or start as a shipbuilder">
<node TEXT="Repair ships">
<node TEXT="Renew the painting"/>
<node TEXT="Fix broken things"/>
</node>
<node TEXT="Build up new ships"/>
</node>
<node TEXT="As an officer">
<icon BUILTIN="idea"/>
<icon BUILTIN="help"/>
</node>
<node TEXT="As a cleaner"/>
</node>
<node TEXT="Create a board of managers">
<icon BUILTIN="idea"/>
<icon BUILTIN="help"/>
<node TEXT="Only for bigger companies"/>
</node>
<node TEXT="Design your own ships">
<node TEXT="From templates (default ships)"/>
<node TEXT="Or your complete freely designed layout"/>
</node>
<node TEXT="Ride constructed ships">
<node TEXT="Make sail plans"/>
<node TEXT="Transportate cargo or humans">
<node TEXT="Make your passengers happy"/>
<node TEXT="Load containers and bring them to other harbors"/>
<node TEXT="Transportate oil from ricks to the refineries"/>
</node>
<node TEXT="Depends on used client"/>
</node>
<node TEXT="Earn a lot (virtual/real) money">
<node TEXT="Sell a journey"/>
<node TEXT="Trade with goods"/>
<node TEXT="Construct ships for other companies"/>
</node>
<node TEXT="Play as a passenger">
<node TEXT="Order a jorney to your desired destionation"/>
</node>
</node>
<node TEXT="Multi-Player Mode" POSITION="right">
<font NAME="SansSerif" BOLD="true" SIZE="16"/>
<icon BUILTIN="messagebox_warning"/>
<node TEXT="Networked over hubs"/>
<node TEXT="Big map which holds all harbors">
<node TEXT="Seperated into small maps to cluster the load over the network"/>
</node>
</node>
<node TEXT="Java client" POSITION="left">
<cloud/>
<icon BUILTIN="idea"/>
<node TEXT="Real-time simulation"/>
<node TEXT="OpenGL (3D Graphics)">
<node TEXT="JOGL"/>
</node>
<node TEXT="OpenAL (3D sound)"/>
</node>
<node TEXT="&quot;Faked&quot; Single-Player" POSITION="right">
<font NAME="SansSerif" BOLD="true" SIZE="16"/>
<icon BUILTIN="messagebox_warning"/>
<node TEXT="Locally installed version"/>
<node TEXT="Does not connect to other hubs"/>
<node TEXT="&quot;Save games&quot; should be incompatible with MP mode">
<node TEXT="Avoids cheating"/>
</node>
</node>
<node TEXT="Sand-Box Mode" POSITION="right">
<font NAME="SansSerif" BOLD="true" SIZE="16"/>
<icon BUILTIN="messagebox_warning"/>
<node TEXT="The player can test the game">
<node TEXT="Some people like to &quot;explore&quot; the game"/>
<node TEXT="Or just wanna have a look"/>
</node>
<node TEXT="There are no competitors">
<font NAME="SansSerif" SIZE="12"/>
</node>
<node TEXT="Creating characters is for free"/>
<node TEXT="The game will not connect to network"/>
<node TEXT="Characters are invalid to multi/single-player characters">
<node TEXT="Prevents cheating a bit">
<icon BUILTIN="clanbomber"/>
</node>
</node>
</node>
<node TEXT="Modern-epoche game" POSITION="left">
<node TEXT="Age: 1950+"/>
<node TEXT="The abstraction level is kept low"/>
</node>
<node TEXT="Licences" POSITION="left">
<node TEXT="The game">
<node TEXT="Ship-Simu is licensed under the GNU GPL 3 or any newer version">
<node TEXT="See docs/COPYING.software"/>
</node>
</node>
<node TEXT="This document">
<node TEXT="This mind-map is licensed under the GNU FDL 1.2 or any newer version">
<node TEXT="See docs/COPYING.documents"/>
</node>
</node>
<node TEXT="Artworks like sounds/graphics">
<node TEXT="Some CC license">
<icon BUILTIN="xmag"/>
</node>
</node>
</node>
<node TEXT="Data exchange protocol" POSITION="right">
<node TEXT="Default is an own small format">
<node TEXT="Reduces traffic between servers"/>
</node>
<node TEXT="Easy rewriteable to e.g. XML">
<node TEXT="Other clients (Flash) can also connect"/>
</node>
<node TEXT="Java and browser client can play together"/>
</node>
<node TEXT="Optional Pillory" POSITION="left">
<node TEXT="To make e.g. nazi propaganda activity public"/>
<node TEXT="Shall keep bad players away"/>
<node TEXT="Requires some &quot;game-moderator&quot; access level to manage">
<node TEXT="The moderator shall have an extra flag e.g. &quot;pillory_accessable&quot;"/>
</node>
<node TEXT="Players, companies et cetera should be lockable">
<node TEXT="The moderator can choose wether to lock with pillory entry or just locking down"/>
</node>
</node>
<node TEXT="How do you construct a ship?" POSITION="left">
<font NAME="SansSerif" BOLD="true" SIZE="16"/>
<node TEXT="The technology">
<node ID="_Freemind_Link_34058737" TEXT="Ship">
<node ID="_Freemind_Link_970552884" TEXT="Size"/>
<node ID="_Freemind_Link_446463585" TEXT="Construction">
<node ID="_Freemind_Link_141857388" TEXT="Hull"/>
<node ID="_Freemind_Link_563134447" TEXT="Wheel house"/>
<node ID="_Freemind_Link_1490756383" TEXT="Support (meal) for crew/passenger"/>
<node ID="_Freemind_Link_38506335" TEXT="Rooms">
<node TEXT="Canteen"/>
<node TEXT="Cabin">
<node TEXT="Luxury cabin"/>
<node TEXT="Premier cabin"/>
<node TEXT="Economy cabin"/>
<node TEXT="Low cabin"/>
</node>
<node TEXT="Motor room"/>
<node TEXT="Special rooms">
<node TEXT="Cinema"/>
<node TEXT="Theatre"/>
<node TEXT="Disco"/>
<node TEXT="Bars/Cafes"/>
</node>
</node>
<node TEXT="Engine">
<node TEXT="Sail"/>
<node TEXT="Propeller"/>
</node>
<node TEXT="Decks">
<node TEXT="Car deck"/>
<node TEXT="Truck deck"/>
<node TEXT="Train deck"/>
</node>
</node>
<node TEXT="Crew (depending on ship type)">
<node TEXT="Sailor/captain"/>
<node TEXT="Cleaners"/>
<node TEXT="Security service"/>
<node TEXT="Maintenance staff"/>
<node TEXT="Catering staff">
<node TEXT="Cook"/>
<node TEXT="Steward (passenger ship)"/>
</node>
</node>
</node>
</node>
<node TEXT="The economics">
<node ID="_Freemind_Link_554040694" TEXT="Costs">
<node ID="_Freemind_Link_1671691099" TEXT="Ressources">
<node ID="_Freemind_Link_1385368958" TEXT="Wood">
<node TEXT="Coverage"/>
<node TEXT="Constructuon (all)"/>
</node>
<node ID="_Freemind_Link_799981169" TEXT="Financials"/>
<node ID="_Freemind_Link_1436100534" TEXT="Iron">
<node TEXT="Steel"/>
</node>
<node TEXT="Marmor"/>
<node TEXT="Color"/>
<node TEXT="Carpets"/>
</node>
<node ID="_Freemind_Link_511748963" TEXT="Work">
<node ID="_Freemind_Link_578404113" TEXT="Worker">
<node ID="_Freemind_Link_1864981448" TEXT="Qualified">
<node TEXT="Fast"/>
<node TEXT="Hight-quality work"/>
<node TEXT="Expensive"/>
</node>
<node ID="_Freemind_Link_894167206" TEXT="Helper (non-qualified)">
<node TEXT="Slow"/>
<node TEXT="Low-quality work"/>
<node TEXT="Cheap"/>
</node>
</node>
<node ID="_Freemind_Link_1901309571" TEXT="Employee morale"/>
<node TEXT="Salary"/>
</node>
</node>
</node>
<node TEXT="The research"/>
<node TEXT="Unsorted ideas">
<icon BUILTIN="pencil"/>
<node TEXT="All buildings shall gain a basic tech-level"/>
<node TEXT="Some parts of the ship or building are only available at or above a tech-level"/>
<node TEXT="Tech levels can be improved by research"/>
<node TEXT="General research complexes can increase tech-level of all types of buildings and ship parts"/>
<node TEXT="Doing resarch requires a lot money"/>
<node TEXT="Specialists must be hired for doing the research"/>
<node TEXT="Ship yards are highly required to construct ships">
<node TEXT="Without these facilities the gamer shall never be able to construct ships"/>
</node>
<node TEXT="Hired workers must be trained to do simple steps"/>
</node>
</node>
<node TEXT="Misc" POSITION="right">
<font NAME="SansSerif" BOLD="true" SIZE="16"/>
<node TEXT="Websites">
<font NAME="SansSerif" BOLD="true" SIZE="14"/>
<node LINK="http://www.ship-simu.org" TEXT="Homepage (www.ship-simu.org)">
<icon BUILTIN="gohome"/>
</node>
<node LINK="http://forum.ship-simu.org" TEXT="Forum (forum.ship-simu.org)"/>
<node LINK="http://bugs.ship-simu.org" TEXT="Bug tracker (bugs.ship-simu.org)"/>
</node>
<node TEXT="Author">
<font NAME="SansSerif" BOLD="true" SIZE="14"/>
<node TEXT="Roland &quot;Quix0r&quot; Haeder">
<node TEXT="Main author"/>
<node LINK="mailto:webmaster@ship-simu.org" TEXT="webmaster@ship-simu.org"/>
<node TEXT="8809296">
<icon BUILTIN="licq"/>
</node>
</node>
</node>
<node TEXT="Ideas">
<font NAME="SansSerif" BOLD="true" SIZE="14"/>
<node TEXT="Roland &quot;Quix0r&quot; Haeder">
<node TEXT="Main concept"/>
<node TEXT="Translation of monakoianar&apos;s ideas to english"/>
</node>
<node TEXT="Dominik &quot;monakoianar&quot; Schmauder">
<node TEXT="Helps finding a lot major ideas"/>
<node LINK="mailto:dominikschmauder@gmx.de" TEXT="dominikschmauder@gmx.de"/>
<node TEXT="268853027">
<icon BUILTIN="licq"/>
</node>
</node>
</node>
</node>
</node>
</map>
